uses s_utils;
{Script that bet martingale on sleeping elements.
 Easy to add/remove elements.
 All elements are independent.
 Author Silver. Version 1.5.
 BetVoyager zero table
 }

var chips, k_el, start_amount, wish_amount, amount, yesno, spin_count, fl_stop, was_betting, stop_loss;
var elements, elements_played;

procedure stack_array(sa_nr);
 var k;
begin
 for k:=0 to VarArrayHighBound(elements,1) do begin//here we go through the all elements
   if elements[k,7]=0 then continue;//in case play_cnt=0 we ignore this element
   if number_is(sa_nr,elements[k,4]) then begin
     elements[k,0]:=0;//in case the red land counter is again 0
     if elements[k,2]>=1 then begin
       amount:=amount+(elements[k,5,elements[k,2]]*(elements[k,3]-(elements[k,6]-1)));//in case the red win we increase the amount
       print('We have bet $'+FormatFloat('0.##',elements[k,5,elements[k,2]])+' on '+elements[k,4]+' and win.');
       if elements[k,7]<>-1 then elements[k,7]:=elements[k,7]-1;//we decrease the play_cnt
     end;
     elements[k,2]:=0;//in case the red land cnt_progression became 0, so we again wait for red not to apear x times
   end else begin
     if elements[k,2]>=1 then begin
       amount:=amount-(elements[k,5,elements[k,2]]*elements[k,6]);//in case the red lose we decrese amount with how much we bet on red
       print('We have bet $'+FormatFloat('0.##',elements[k,5,elements[k,2]])+' on '+elements[k,4]+' and lose.');
     end;
     elements[k,0]:=elements[k,0]+1;//in case the red didn't land counter is increased
   end;
 end;
end;

begin
 {Wait for a element not to hit in "X" times, and then bet progression.
0 didn_apear - indicate how much spins the element didn't lan
1 alert - indicate how much spins we must wait for element didn't apear
2 cnt_progression - store the current number from progresiion array
3 win_coeficient - indicate how much increase the bet on winning
4 name - indicate the name of element (look at the s_utils module to get the name, or to add your own names)
5 martingale_progression - indicate the element's progression
6 cnt_elements - indicate how much same table-elements we have in the group, usuall =1 (for example we have [0,10,0,??,'groupA'[0,1,1,1,2,2,3,4,5,7,9,12]
  where groupA - is the 9 singles. In this case the win_coeficient must remain 35, and the cnt_elements=9.
  So the correct will be [0,10,0,35,'groupA',[0,1,1,1,2,2,3,4,5,7,9,12],9])
7 play_cnt - indicate how much times the element will play
  (-1 - the element will always play; 0 - the element will not play; 1 - the element will play only once; 2 - only 2 times; 3 - only 3 times; ...)
  (in this example: red - will play always; column1 - will play 3 times; single0-will never play; street4 - will play 1 time.)

 you must change only the alert, win_coeficient, name, martingale_progression, cnt_elements, play_cnt}

 elements:=[
            [0,4,0,1,'low',[0,1,2,4,8,16,32,64],1,-1],
            [0,5,0,2,'column1',[0,1,3,9,27],1,3],
            [0,40,0,35,'single1',[0,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3],1,0],
            [0,13,0,11,'street4',[0,1,1,3,4,6,9,14],1,1] //street4-numbers 10,11,12
           ];

 //chips value's
 //chips:=[0,0.01,0.10,1,5,10,25,100];//here you need to specify chip values
 chips:=[0,0.01,0.1,0.5,1,5,10,25,50,100];//here you need to specify chip values

 //enter the start_amount
 start_amount:=987.73;
 amount:=start_amount;//current amount became start_amount

 //enter how much you want to increase your start_amount
 wish_amount:=start_amount+100;

 //enter the stop_loss, if stop_loss=0 it will not be used, with other words stop_loos will be the end of balance
 stop_loss := 800;
  
 yesno:='no';
 InputQuery('Query window','Are you sure to run? yes/no ',yesno);
 if not ((yesno='yes') or (yesno='y')) then exit;

 spin_count:=1; was_betting:=1; fl_stop:=0; elements_played:=0;

while amount<wish_amount do begin
  //if (was_betting=1)and(sim_mode<>1) then begin ide_delay:=250;click_chip1();click_red();click_chip2();click_even();click_clear_bets(); end;
  was_betting:=0;

  elements_played:=0;
  for k_el:=0 to VarArrayHighBound(elements,1) do begin
    if (elements[k_el,0]>=elements[k_el,1])and(elements[k_el,7]<>0) then begin //here we check if red didn't apear the wished spins and the play_cnt<>0
      elements[k_el,2]:=elements[k_el,2]+1;//if red didn't apear the wished numbers of spin we increase the cnt_progression
      if elements[k_el,2]=1 then print('Start betting on '+elements[k_el,4]+'.');
      if elements[k_el,2]>VarArrayHighBound(elements[k_el,5],1) then begin fl_stop:=1; break; end;; //here we check if we reach the end of progresion and loose, in this case the game stops
      bet_x_on_y(elements[k_el,5,elements[k_el,2]],[elements[k_el,4]],chips);//here we bet
      was_betting:=1;
    end;
    if elements[k_el,7]=0 then elements_played:=elements_played+1;
  end;

  if was_betting=0 then bet_x_on_y(chips[1],['red','black'],chips);//here we bet on red and black - instead of free spin
  if (fl_stop=1)or(elements_played=VarArrayHighBound(elements,1)+1) then break;

  click_spin_button();
  stack_array(get_last_landed_number());
  print('Spin count - '+IntToSTr(spin_count)+'. Landed numbrer is '+IntToStr(get_last_landed_number())+'. Current amount is $'+FormatFloat('0.##',amount));
  if amount<=stop_loss then break;
  Inc(spin_count);
end;

if not (amount>=wish_amount) then print('The game stops because we reach the end of progression or reach the stop loss or all elements played their games, and lose.'+'. Current amount is $'+FormatFloat('0.##',amount))
                             else print('Congratulations! The game stops because we reach wishing amount.'+'. Current amount is $'+FormatFloat('0.##',amount));
print('Current amount is $'+FormatFloat('0.##',amount)+'. Start balance is $'+FormatFloat('0.##',start_amount)+'. Stop loss is $'+FormatFloat('0.##',stop_loss)+'. Wishing amount is $'+FormatFloat('0.##',wish_amount)+'.');
end;
