{$FORM TForm2, Unit2.sfm}

uses
  Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, 
  StdCtrls, s_utils;

{File Variables}
var F : Text;
    S : String;  
var i;
var chips, k_el, k_el1, start_amount, wish_amount, amount, yesno, spin_count, fl_stop, was_betting, sim_mode, stop_loss;
var elements, elements1, elements_played, total_elements, last_nr;  

{#### Window Operations ##############################################}
procedure close_me;
begin
    if Self.Top<0 then Self.Top:=0;
    if Self.Left<0 then Self.Left:=0;
    AssignFile(F,'c:\rss-data\bv_winpos');
    Rewrite(F);              
    Writeln(F,Self.Top);
    Writeln(F,Self.Left);
    CloseFile(F); 
end;

procedure load_winpos; 
begin
    AssignFile(F,'c:\rss-data\bv_winpos');{If no file exist. Then you will get an error message}
    Reset(F);{open the file for reading}
    i := 0;
    while not eof(F) do {loop that will repeat until the end of file will be not found}
    begin
        S:=ReadLn(F); {read the first line into "s" variable}
        if i=0 then Self.Top:=s;
        if i=1 then Self.Left:=s;
        i := i+1;
    end;
    CloseFile(F);//close the file
end;
{#### End: Window Operations #########################################}

{#### Memo Operations ################################################}
procedure marque;
begin
    if number_is(last_nr,'red')then begin
      Memo_RN.Lines.Insert(0,last_nr);
      Memo_BN.Lines.Insert(0,'');
    end else begin
      Memo_RN.Lines.Insert(0,'');
      Memo_BN.Lines.Insert(0,last_nr);
    end;
end;

procedure print_to_memo(arg1);
begin
    Memo_Results.Lines.Add(arg1);
end;
{#### End: Memo Operations ###########################################}

procedure add_systems;
begin
elements:=[
[0,4,0,1,'red',[0,1,2,4,8,16,32,64],1,-1],
[0,4,0,1,'black',[0,1,2,4,8,16,32,64],1,-1],
[0,4,0,1,'low',[0,1,2,4,8,16,32,64],1,-1],
[0,5,0,2,'column1',[0,1,3,9,27],1,3],
[0,40,0,35,'single1',[0,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3],1,0],
[0,13,0,11,'street4',[0,1,1,3,4,6,9,14],1,1] //street4-numbers 10,11,12
];
end;

procedure stack_array(sa_nr);
 var k;
begin
 for k:=0 to VarArrayHighBound(elements,1) do begin//here we go through the all elements
   if elements[k,7]=0 then continue;//in case play_cnt=0 we ignore this element
   if number_is(sa_nr,elements[k,4]) then begin
     elements[k,0]:=0;//in case the red land counter is again 0
     if elements[k,2]>=1 then begin
       amount:=amount+(elements[k,5,elements[k,2]]*(elements[k,3]-(elements[k,6]-1)));//in case the red win we increase the amount
       print_to_memo('We have bet $'+FormatFloat('0.##',elements[k,5,elements[k,2]])+' on '+elements[k,4]+' and win.');
       if elements[k,7]<>-1 then elements[k,7]:=elements[k,7]-1;//we decrease the play_cnt
     end;
     elements[k,2]:=0;//in case the red land cnt_progression became 0, so we again wait for red not to apear x times
   end else begin
     if elements[k,2]>=1 then begin
       amount:=amount-(elements[k,5,elements[k,2]]*elements[k,6]);//in case the red lose we decrese amount with how much we bet on red
       print_to_memo('We have bet $'+FormatFloat('0.##',elements[k,5,elements[k,2]])+' on '+elements[k,4]+' and lose.');
     end;
     elements[k,0]:=elements[k,0]+1;//in case the red didn't land counter is increased
   end;
 end;
end;

procedure Button_StartClick(Sender: TObject);
begin
	add_systems;
	start_amount:=StrToFloat(Edit_Balance.Text);
    amount:=start_amount;
    wish_amount:=amount+StrToFloat(Edit_Profit.Text);
	stop_loss :=StrToFloat(Edit_StopLoss.Text);
	spin_count:=1; 
	was_betting:=1; 
	fl_stop:=0; 
	elements_played:=0;
	while amount<wish_amount do begin
  //if (was_betting=1)and(sim_mode<>1) then begin ide_delay:=250;click_chip1();click_red();click_chip2();click_even();click_clear_bets(); end;
  was_betting:=0;

  elements_played:=0;
  for k_el:=0 to VarArrayHighBound(elements,1) do begin
    if (elements[k_el,0]>=elements[k_el,1])and(elements[k_el,7]<>0) then begin //here we check if red didn't apear the wished spins and the play_cnt<>0
      elements[k_el,2]:=elements[k_el,2]+1;//if red didn't apear the wished numbers of spin we increase the cnt_progression
      if elements[k_el,2]=1 then print_to_memo('Start betting on '+elements[k_el,4]+'.');
      if elements[k_el,2]>VarArrayHighBound(elements[k_el,5],1) then begin fl_stop:=1; break; end;; //here we check if we reach the end of progresion and loose, in this case the game stops
      bet_x_on_y(elements[k_el,5,elements[k_el,2]],[elements[k_el,4]],chips);//here we bet
      was_betting:=1;
    end;
    if elements[k_el,7]=0 then elements_played:=elements_played+1;
  end;

  if was_betting=0 then bet_x_on_y(chips[1],['red','black'],chips);//here we bet on red and black - instead of free spin
  if (fl_stop=1)or(elements_played=VarArrayHighBound(elements,1)+1) then break;

  click_spin_button();
  stack_array(get_last_landed_number());
  last_nr:=get_last_landed_number(); marque;
  print_to_memo('Spin count - '+IntToSTr(spin_count)+'. Landed numbrer is '+IntToStr(get_last_landed_number())+'. Current amount is $'+FormatFloat('0.##',amount));
  if amount<=stop_loss then break;
  Inc(spin_count);
end;

end;

procedure Button_StopClick(Sender: TObject);
begin
	fl_stop:=1; 
end;

procedure Edit_BalanceKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
    begin           
        Key := #0;
    end;
end;

procedure Edit_ProfitKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
    begin           
        Key := #0;
    end;
end;       

procedure Edit_StopLossKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
    begin           
        Key := #0;
    end;
end;

procedure Form2Activate(Sender: TObject);
begin
    load_winpos;
	chips:=[0,0.01,0.1,0.5,1,5,10,25,50,100];//here you need to specify chip values
end;           

procedure Form2Close(Sender: TObject; var Action: TCloseAction);
begin
    close_me;
end;

begin
end;
